<template>
  <Row class="register-page">
    <div class="body-block" v-if="displayBodyBlock">
      <Spin size="large" fix></Spin>
    </div>
    <i-col :lg="{offset: 8, span: 8}" :md="{offset: 8, span: 8}" class="form-box">
      <div class="register-form">
        <div class="form-body" @keyup.enter="submitAction">
          <div class="form-title">
            <h1> Register </h1>
          </div>
          <stock-form-item v-for="(field, index) in schemaFields(registerForm.schema)" :key="field"
                           v-model="registerForm.data[field]"
                           :options="registerForm.schema[field]"
                           :error="registerForm.error[field]"
                           :edit="true">
          </stock-form-item>
          <Row>
            <div class="literal-div-btn login-btn" @click="$redirectTo('login')">Login</div>
            <div class="literal-div-btn register-btn" @click="submitAction">Register</div>
          </Row>
        </div>
      </div>
    </i-col>
  </Row>
</template>

<script>
  import StockForm from "../components/StockForm";
  import { mixin, basicForm } from "../helpers/form";
  import StockFormItem from "../components/StockFormItem";
  import { mapActions } from "vuex";
  import { validators as api } from '../configs/request-validator/user';

  const actions = {
    async submitAction() {
      try {
        this.displayBodyBlock = true;
        await this.$api(api.CreateUserRequest, this.registerForm.data, 'user');
        this.$redirectTo('login');
      } catch(error) {
        this.displayBodyBlock = false;
        this.registerForm.error = this.$apiErrorHandler(error) || {};
      }
    },
  };

  export default {
    name: 'index',
    mixins: [ mixin ],
    components: {StockFormItem, StockForm},
    data() {
      return {
        displayBodyBlock: false,
        registerForm: undefined,
      };
    },
    methods: {
      ...mapActions(['setToken']),
      ...actions,
    },
    mounted() {
      this.$displayBodyBlock(false);
    },
    asyncData({ store, redirect }) {
      const hasToken = store.getters.hasToken;
      if (hasToken) {
        redirect('/');
      }

      const registerForm = {
        ...basicForm,
        schema: {
          name: { type: 'text', title: 'Name' },
          email: { type: 'text', title: 'Email' },
          phone: { type: 'text', title: 'Phone' },
          password: { type: 'password', title: 'Password' },
          password_confirmation: { type: 'password', title: 'Confirm Password' },
        },
        rules: api.CreateUserRequest.body,
        data: {
          name: undefined,
          email: undefined,
          phone: undefined,
          password: undefined,
          password_confirmation: undefined,
        }
      };

      return { registerForm };
    },
  }
</script>

<style lang="scss" scoped>
  @import "../assets/css/mixin";

  .register-page {
    height: 100vh;
    background-image: url("/images/background.jpg");
    background-size: cover;
    background-repeat: no-repeat;
    overflow-y: auto;
    .body-block {
      position: absolute;
      height: 100vh;
      width: 100vw;
      top: 0;
      left: 0;
      z-index: 2;
    }
    .ivu-spin-fix {
      background-color: rgba(4, 18, 42, 0.4);
    }
    .form-box {
      height: 100%;
      .register-form {
        position: relative;
        top: 20%;
        margin-bottom: 60px;
        .form-body {
          border-radius: 8px;
          padding: 20px;
          .form-title {
            text-align: center;
          }
        }
      }
    }
  }
</style>
